// viewer.cpp : implementation file
//

#include "stdafx.h"
#include "nstest.h"
#include "viewer.h"
#include "nstesdoc.h"

#ifdef _DEBUG
#undef THIS_FILE
static char BASED_CODE THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExternalStreamingViewer

IMPLEMENT_DYNCREATE(CExternalStreamingViewer, CCmdTarget)

CExternalStreamingViewer::CExternalStreamingViewer()
{
	EnableAutomation();
	
	// To keep the application running as long as an OLE automation 
	//	object is active, the constructor calls AfxOleLockApp.
	
	AfxOleLockApp();
	
	//	Create an empty document that we can interact with.
	m_pDoc = (CNstestDoc *)((CNstestApp *)AfxGetApp())->OpenDocumentNew();
	if(m_pDoc == NULL)	{
		AfxThrowOleException(E_UNEXPECTED);
	}
	
	//	We'll want the user to see this new document.
	//	Doesn't matter if we're hidden or in the back ground,
	//		bring us up to the front.
	AfxGetApp()->m_pMainWnd->ShowWindow(SW_SHOW);
}

CExternalStreamingViewer::~CExternalStreamingViewer()
{
	// To terminate the application when all objects created with
	// 	with OLE automation, the destructor calls AfxOleUnlockApp.
	
	AfxOleUnlockApp();
}

void CExternalStreamingViewer::OnFinalRelease()
{
	// When the last reference for an automation object is released
	//	OnFinalRelease is called.  This implementation deletes the 
	//	object.  Add additional cleanup required for your object before
	//	deleting it from memory.

	delete this;
}


BEGIN_MESSAGE_MAP(CExternalStreamingViewer, CCmdTarget)
	//{{AFX_MSG_MAP(CExternalStreamingViewer)
		// NOTE - the ClassWizard will add and remove mapping macros here.
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

BEGIN_DISPATCH_MAP(CExternalStreamingViewer, CCmdTarget)
	//{{AFX_DISPATCH_MAP(CExternalStreamingViewer)
	DISP_FUNCTION(CExternalStreamingViewer, "Close", Close, VT_EMPTY, VTS_I2)
	DISP_FUNCTION(CExternalStreamingViewer, "Initialize", Initialize, VT_I2, VTS_BSTR VTS_BSTR)
	DISP_FUNCTION(CExternalStreamingViewer, "Ready", Ready, VT_I4, VTS_NONE)
	DISP_FUNCTION(CExternalStreamingViewer, "Write", Write, VT_EMPTY, VTS_PBSTR VTS_I4)
	//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

IMPLEMENT_OLECREATE(CExternalStreamingViewer, "Nstest.Viewer.1", 0x37ff8636, 0x64a9, 0x11ce, 0x8c, 0xe4, 0x0, 0x20, 0xaf, 0x18, 0xf9, 0x5)

/////////////////////////////////////////////////////////////////////////////
// CExternalStreamingViewer message handlers


void CExternalStreamingViewer::Close(short iStatus) 
{
	// TODO: Add your dispatch handler code here
	char aBuf[512];
	sprintf(aBuf, "OLE void CExternalStreamingViewer::Close(%d);", iStatus);
	m_pDoc->Display(aBuf);
	
	//	All done, check the status to see if the load finished normally.
}

short CExternalStreamingViewer::Initialize(LPCTSTR pMimeType, LPCTSTR pUrl) 
{
	// TODO: Add your dispatch handler code here
	short sRetval = 1;
	
	char aBuf[2048];
	sprintf(aBuf, "OLE %d CExternalStreamingViewer::Initialize(%s,%s);", sRetval, pMimeType, pUrl);
	m_pDoc->Display(aBuf);

	//	Deny or accept.
	return sRetval;
}

long CExternalStreamingViewer::Ready() 
{
	// TODO: Add your dispatch handler code here
	long lRetval = rand() - 1024;
	if(lRetval < 0)	{
		lRetval = 0;
	}
	
	char aBuf[512];
	sprintf(aBuf, "OLE %ld CExternalStreamingViewer::Ready();", lRetval);
	m_pDoc->Display(aBuf);
    
    //	Report the number of bytes we're ready to handle.
	return lRetval;
}

void CExternalStreamingViewer::Write(BSTR FAR* pData, long lBytes) 
{
	// TODO: Add your dispatch handler code here
	// Accept incoming data and process.
	
	//	Copy over the data into our buffer.
	char *pCopy = new char[lBytes + 1];
	strncpy(pCopy, *pData, lBytes);
	pCopy[lBytes] = '\0';
	
	char *pBuf = new char[lBytes + 512];
	sprintf(pBuf, "OLE void CExternalStreamingViewer::Write(%s, %ld);", pCopy, lBytes);
	m_pDoc->Display(pBuf);
	
	delete[] pCopy;
	delete[] pBuf;
}
